<template>
  <b-container fluid>
    <b-table
      responsive
      striped
      hover
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      :items="results"
      :fields="fields"
      :current-page="currentPage"
      :per-page="perPage"
      class="table-platone"
    >
      <template #cell(pod)="data">
        {{ data.item.pod }}
      </template>
       <template #cell(smartContractId)="data">
        {{ data.item.smartContractId }}
      </template>
      <template #cell(aggregatorId)="data">
        {{ data.item.aggregatorId }}
      </template>
      <template #cell(zone)="data">
        {{ data.item.zone }}
      </template>
      <template #cell(pomId)="data">
        {{ data.item.pomId }}
      </template>
      <template #cell(pnp)="data">
        {{ data.item.pnp }}
      </template>
      <template #cell(inp)="data">
        {{ data.item.inp }}
      </template>
      <template #cell(inq)="data">
        {{ data.item.inq }}
      </template>
      <template #cell(cnq)="data">
        {{ data.item.cnq }}
      </template>
      <template #cell(cosPhi)="data">
        {{ data.item.cosPhi }}
      </template>
      <template #cell(upperP)="data">
        {{ data.item.maxFlexibility.upperP }}
      </template>
      <template #cell(downP)="data">
        {{ data.item.maxFlexibility.downP }}
      </template>
      <template #cell(upperQ)="data">
        {{ data.item.maxFlexibility.upperQ }}
      </template>
      <template #cell(downQ)="data">
        {{ data.item.maxFlexibility.downQ }}
      </template>
      <template #cell(powerBaselineCurves)="data">
        <b-button v-b-tooltip.hover title="Workday" size="sm" class="mf-1" v-on:click="fillData(data.item.powerBaselineCurves.workday)" v-b-modal.modalP>W</b-button>
        <b-button v-b-tooltip.hover title="Preholiday" size="sm" class="mf-1" v-on:click="fillData(data.item.powerBaselineCurves.preholiday)" v-b-modal.modalP>P</b-button>
        <b-button v-b-tooltip.hover title="Holiday" size="sm" class="mf-1" v-on:click="fillData(data.item.powerBaselineCurves.holiday)" v-b-modal.modalP>H</b-button>
      </template>
    </b-table>
    <b-pagination
      v-model="currentPage"
      :total-rows="results.length"
      :per-page="perPage"
      aria-controls="my-table"
    ></b-pagination>
    <b-modal id="modalP" title="Chart" hide-footer size="xl" @ok="handleOk" ref="modal">
          <line-chart class="line-chart" :chart-data="datacollection" :options="options"></line-chart>
    </b-modal>
  </b-container>
</template>

<style>
.btn-sm, .btn-group-sm > .btn {
    padding: 0.25rem 0.25rem;
    font-size: 12px;
    line-height: 1.5;
    border-radius: 0.2rem;
}
.create-button {
  margin-bottom: 20px;
}
.mf-1{
  color: #fff;
  background-color: #4d7a77;
}
.line-chart {
  height : 300px;
}
</style>

<script>
import PodsService from '@/services/PodsService'
import LineChart from './LineChart.js'

export default {
  components: {
    LineChart
  },
  mounted () {
    this.getPods()
  },
  data () {
    return {
      options: {
        responsive: true,
        maintainAspectRatio: false,
        scales: {
          xAxes: [
            {
              type: 'time',
              time: {
                unit: 'hour'
              }
            }
          ],
          yAxes: []
        }
      },
      datacollection: null,
      sortBy: 'start',
      sortDesc: true,
      results: [],
      fields: [
        { key: 'pod', label: 'Pod Id', sortable: true },
        { key: 'smartContractId', label: 'Smart Contract', sortable: true },
        { key: 'aggregatorId', label: 'Aggregator', sortable: true },
        { key: 'zone', label: 'Zone', sortable: true },
        { key: 'pomId', label: 'PoM Id', sortable: true },
        { key: 'pnp', label: 'pnp', sortable: true },
        { key: 'inp', label: 'inp', sortable: true },
        { key: 'inq', label: 'inq', sortable: true },
        { key: 'cnq', label: 'cnq', sortable: true },
        { key: 'cosPhi', label: 'cosPhi', sortable: true },
        { key: 'upperP', label: 'upperP', sortable: true },
        { key: 'downP', label: 'downP', sortable: true },
        { key: 'upperQ', label: 'upperQ', sortable: true },
        { key: 'downQ', label: 'downQ', sortable: true },
        { key: 'powerBaselineCurves', label: 'Baseline', sortable: true }
      ],
      form: {},
      currentPage: 1,
      perPage: 10,
      chartOptions1: {
        colors: ['#002f6c', '#c43e00', '#003d00'],
        chart: {
          height: 350,
          type: 'line'
        },
        dataLabels: {
          enabled: false
        },
        legend: {
          display: false
        },
        xaxis: {
          type: 'datetime'
        },
        yaxis: {
          title: {
            text: 'Power (Kw)'
          }
        }
      },
      series: null
    }
  },
  methods: {
    async getPods () {
      const response = await PodsService.getPods()
      this.results = response.data
    },
    handleOk (evt) {
      // Prevent modal from closing
      evt.preventDefault()
    },
    fillData (data) {
      this.datacollection = {
        datasets: [
          { label: 'Active Power',
            borderColor: '#218838',
            tension: 0.1,
            fill: false,
            data: [] },
          { label: 'Reactive Power',
            borderColor: '#47d4f7',
            tension: 0.1,
            fill: false,
            data: [] }
        ]
      }
      for (let i = 0; i < data.length; i += 1) {
        let index = 0
        if (data[i].index && Number.isInteger(data[i].index)) {
          index = data[i].index
        } else if (data[i].timeSlotIndex && Number.isInteger(data[i].timeSlotIndex)) {
          index = data[i].timeSlotIndex
        }
        if (Number.isInteger(index)) {
          const timestamp = new Date()
          timestamp.setHours(0, 0, 0)
          timestamp.setMinutes(timestamp.getMinutes() + Number(index * 15))
          this.datacollection.datasets[0].data.push({ x: timestamp, y: data[i].p })
          this.datacollection.datasets[1].data.push({ x: timestamp, y: data[i].q })
        }
      }
      console.log(this.datacollection)
    }
  }
}
</script>
